package com.zt.plat.module.qms.resource.material.dal.mapper;

import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialInventoryCheckItemPageReqVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialInventoryCheckItemRespVO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialInventoryCheckItemDO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialProductDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 库存盘点项 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface MaterialInventoryCheckItemMapper extends BaseMapperX<MaterialInventoryCheckItemDO> {

    default PageResult<MaterialInventoryCheckItemDO> selectPage(MaterialInventoryCheckItemPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<MaterialInventoryCheckItemDO>()
                .eqIfPresent(MaterialInventoryCheckItemDO::getParentId, reqVO.getParentId())
                .eqIfPresent(MaterialInventoryCheckItemDO::getProductId, reqVO.getProductId())
                .eqIfPresent(MaterialInventoryCheckItemDO::getExpected, reqVO.getExpected())
                .eqIfPresent(MaterialInventoryCheckItemDO::getActual, reqVO.getActual())
                .eqIfPresent(MaterialInventoryCheckItemDO::getDifference, reqVO.getDifference())
                .eqIfPresent(MaterialInventoryCheckItemDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .eqIfPresent(MaterialInventoryCheckItemDO::getRemark, reqVO.getRemark())
                .betweenIfPresent(MaterialInventoryCheckItemDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(MaterialInventoryCheckItemDO::getId));
    }

    default List<MaterialInventoryCheckItemRespVO> selectListWithPdtInfoByLfcId(Long lfcId) {
        MPJLambdaWrapper<MaterialInventoryCheckItemDO> wrapper = new MPJLambdaWrapperX<MaterialInventoryCheckItemDO>()
                .selectAll(MaterialInventoryCheckItemDO.class)
                .selectAs(MaterialProductDO::getName, MaterialInventoryCheckItemRespVO::getProductName)
                .selectAs(MaterialProductDO::getCode, MaterialInventoryCheckItemRespVO::getProductCode)
                .selectAs(MaterialProductDO::getSpecification, MaterialInventoryCheckItemRespVO::getProductSpecification)
                .selectAs(MaterialProductDO::getModelNo, MaterialInventoryCheckItemRespVO::getProductModelNo)
                .select(MaterialProductDO::getUnit)
                .leftJoin(MaterialProductDO.class, MaterialProductDO::getId, MaterialInventoryCheckItemDO::getProductId)
                .eq(MaterialInventoryCheckItemDO::getParentId, lfcId);
        return selectJoinList(MaterialInventoryCheckItemRespVO.class, wrapper);
    }
}